/*
 * main.c
 *
 * $author scrockman (scrockman@gmail.com)
 * $license GPLv3
 *
 * Testing: gcc main.c requestsplitter.c requestsplitter.h -o requestsplitter && ./requestsplitter http://www.google.it/dir1/dir2/dir3/index.php
 */

#include "requestsplitter.h"

int main(int argc, char *argv[]) {

	if(argc != 2) {
		fprintf(stderr, "Usage: splitter <uri>\n");
		return 0;
	}

	// Extract protocol, host and page (first method)
	int p = extractProtocolFromUri(argv[1]);
	char *h = extractHostFromUri(argv[1]);
	char *pa = extractPageFromUri(argv[1]);

	// Extract protocol, host and page (second method)
	request_type request;
	int r = string2Request(&request, argv[1]);

	// Show the protocol
	switch(request.protocol /*p*/) {
		case 1:
			printf("protocol: http://\n");
			break;
		case 2:
			printf("protocol: https://\n");
			break;
		default:
			fprintf(stderr, "protocol: unrecognized\n");
			break;
	}

	// Show and free the host
	printf("Host....: %s\n", /*h*/ request.host);
	free(h);

	// Show and free the page
	printf("Page....: %s\n", /*pa*/ request.page);
	free(pa);

	// Return the success
	return 0;

}
