/*
 * requestsplitter.c
 *
 * $author scrockman@gmail.com
 * $license GPLv3
 */

#include "requestsplitter.h"

int extractProtocolFromUri(char *uri) {

	// Http
	if(strncmp(uri, "http://", strlen("http://")) == 0) {
		return 1;
	}

	// Https
	if(strncmp(uri, "https://", strlen("https://")) == 0) {
		return 2;
	}

	// Unknown
	return 0;

}

char *extractHostFromUri(char *uri) {

	int i;
	int j;
	char *newstr;

	// Skip the protocol
	switch(extractProtocolFromUri(uri)) {
		case 1:
			uri += strlen("http://");
			break;
		case 2:
			uri += strlen("https://");
			break;
		default:
			return 0;
	}

	// Extract the host
	for(i = 0; i < strlen(uri); i++) {
		if(uri[i] == '/') {
			newstr = (char *) malloc(i + 1);
			for(j = 0; j < i; j++) {
				newstr[j] = uri[j];
			}
			newstr[i] = 0;
			break;
		}
	}

	// Should be made free later
	return newstr;

}

char *extractPageFromUri(char *uri) {

	int i;
	int j;
	int l;
	char *newstr;

	// Check the protocol
	if(extractProtocolFromUri(uri) == 0) {
		return 0;
	}

	// Skip the host
	for(i = 0, j = 0, l = strlen(uri); i < l; i++) {
		if(uri[i] == '/') {
			j++;
		}
		if(j == 3) {
			uri = &uri[i];
			break;
		}
	}

	// Extract the page
	l = strlen(uri) + 1;
	newstr = (char *) malloc(sizeof(char)*l);
	strcpy(newstr, uri);
	newstr[l] = '\0';

	// Should be made free later
	return newstr;

}

int string2Request(request_type *request, char *uri) {

	// Set the protocol
	request->protocol = extractProtocolFromUri(uri);
	if(request->protocol == 0) {
		return 0;
	}

	// Set the host
	request->host = extractHostFromUri(uri);
	if(request->host == 0) {
		return 0;
	}

	// Set the page
	request->page = extractPageFromUri(uri);
	if(request->page == 0) {
		return 0;
	}

	// Return the success
	return 1;

}
