/*
 * requestsplitter.h
 *
 * $author scrockman@gmail.com
 * $license GPLv3
 */

#ifndef KMS_REQUESTSPLITTER_H
#define KMS_REQUESTSPLITTER_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct request_struct {
	int protocol;
	char *host;
	char *page;
} request_type;

/*
 * extractProtocolFromUri: extract the protocol from the specified URI
 * - uri: the URI
 * - return: 0 = unknown protocol, 1 = http, 2 = https
 */
int extractProtocolFromUri(char *uri);

/*
 * extractHostFromUri: extract the host from the specified URI
 * - uri: the URI
 * - return: the host
 */
char *extractHostFromUri(char *uri);

/*
 * extractPageFromUri: extract the host from the specified URI
 * - uri: the URI
 * - return: the page
 */
char *extractPageFromUri(char *uri);

/*
 * string2Request: make a request using the given uri
 * - request: the request_type pointer
 * - uri: the URI
 * - return: 0 = error, 1 = success
 */
int string2Request(request_type *request, char *uri);

#endif
